/* A simple server in the internet domain using TCP
   The port number is passed as an argument */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sstream>
#include <unistd.h>
#include <iostream>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <vector>
#include "Board.h"
<<<<<<< HEAD
=======
#include "Engine.h"
>>>>>>> master
using namespace std;

void error(const char *msg)
{
    perror(msg);
    exit(1);
}

<<<<<<< HEAD
int main(int argc, char *argv[])
{
     int sockfd, newsockfd, portno;
     socklen_t clilen;
=======
string tempParse(string move) {
	string output = "";
	int tempa = move[0] - '0';
	int tempb = move[1] - '0';
	int tempc = move[2] - '0';
	int tempd = move[3] - '0';
	
	//cout << "move: " << move << " " << tempa << " " << tempb << " " << tempc << " " << tempd << "\n";
	
	for(int c = 0; c < 4; c++) {
		if(!isdigit(move[c])) {
			//cout << "\nfjdkjfjd\n";
			return move;
		}
	}
	if(tempa == (tempc + 1)) {
		//cout << "\nTest\n";
		if(tempb == tempd) {
			output = ((char)('A' + tempb)) + to_string(8 - tempa) + "_f";
		}
		else if(tempb == (tempd + 1)) {
			output = ((char)('A' + tempb)) + to_string(8 - tempa) + "_l";
		}
		else if(tempb == (tempd - 1)) {
			output = ((char)('A' + tempb)) + to_string(8 - tempa) + "_r";
		}
	}
	else {
		return move;
	}
	cout << "Debugging: " << output << "\n\n";
	return output;
}

int main(int argc, char *argv[])
{
    int sockfd, newsockfd, portno;
    socklen_t clilen;
>>>>>>> master
    
	struct sockaddr_in serv_addr, cli_addr;

	int n;
    
	if (argc < 2) {
         fprintf(stderr,"ERROR, no port provided\n");
         exit(1);
<<<<<<< HEAD
     }
     
	 sockfd = socket(AF_INET, SOCK_STREAM, 0);
     
	 if (sockfd < 0) 
        error("ERROR opening socket");
     
	 bzero((char *) &serv_addr, sizeof(serv_addr));
     
	 portno = atoi(argv[1]);
     
	 serv_addr.sin_family = AF_INET;
     
	 serv_addr.sin_addr.s_addr = INADDR_ANY;
     
	 serv_addr.sin_port = htons(portno);
     
	 if (bind(sockfd, (struct sockaddr *) &serv_addr,
              sizeof(serv_addr)) < 0) 
              error("ERROR on binding");
     
	 listen(sockfd,5);
     
	 clilen = sizeof(cli_addr);
     
	 newsockfd = accept(sockfd, 
                 (struct sockaddr *) &cli_addr, 
                 &clilen);
     
	 if (newsockfd < 0) 
          error("ERROR on accept");
	
	//After all the server setup crap is done, we start the board
	
	// cout<<"WELCOME\n";
	
	// cout<<"1. Play against AI?\n";
	// cout<<"2. Play against a human?\n";
	// cout<<"Enter choice: \n";
	
	
	// cin >> choice;
	// cout << "OK" << endl;
	
	Board b;
	string move;
	
	
	bool gameOver = false; 
	b.snapshot();
=======
    }
     
	sockfd = socket(AF_INET, SOCK_STREAM, 0);
     
	if (sockfd < 0) 
       error("ERROR opening socket");
     
	bzero((char *) &serv_addr, sizeof(serv_addr));
     
	portno = atoi(argv[1]);
     
	serv_addr.sin_family = AF_INET;
     
	serv_addr.sin_addr.s_addr = INADDR_ANY;
     
	serv_addr.sin_port = htons(portno);
     
	if (bind(sockfd, (struct sockaddr *) &serv_addr,
            sizeof(serv_addr)) < 0) 
            error("ERROR on binding");
     
	listen(sockfd,5);
     
	clilen = sizeof(cli_addr);
     
	newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
     
	if (newsockfd < 0) 
        error("ERROR on accept");
	
	//After all the server setup crap is done, we start the board
	Engine e;
	string move;
	
	bool gameOver = false; 
	vector<Board> record;
	e.getBoard()->snapshot(record,(*e.getBoard()));
>>>>>>> master
    char buffer[256];
    char info[256];
	int choice;
	int move_counter = 0;
	string final_move;
<<<<<<< HEAD
	
	//Waiting for client to select game type
	n = read(newsockfd,info,255);
	istringstream convert(info);
	convert >> choice; //Sets choice equal to 1 or 2, based on clients input
	bzero(info,256); //Resets info back to normal, "choice" now contains client's value
	
	 while(true) {
		 
		 while(gameOver != true)
		 {
			gameOver = b.isGameOver();
			
			while(b.getTurn() == 'O' )
			{
				b.displayBoard();//Display the board on the server
				string boardState = b.boardToString();
				final_move = b.boardToString();
=======
		
	//Ask client about game type
	string introduction = "WELCOME\n1. Play against AI?\n2. Watch AI vs. AI?\nEnter choice: \n";
	write(newsockfd, introduction.c_str(), introduction.length());
	n = read(newsockfd,info,255); //Reads choice as a string
	istringstream convert(info); //Converts the read string to an integer
	convert >> choice; //Sets value equal to the converted value
	//Later in the project, we need to check for AI and Human modes
	cout << "OK" << endl;
	bzero(info,256); //Resets info back to normal
	
	/*//Becca- once your AI code is working, use this code:
	
	string difficulty_select = "Choose Difficulty\n1. Easy\n2. Medium\n4. Hard\nEnter choice: \n";
	write(newsockfd, difficulty_select.c_str(), difficulty_select.length());
	n = read(newsockfd,info,255);
	istringstream convert(info);
	convert >> choice_difficulty;
	cout << "OK" << endl;
	bzero(info,256);
	
	*/
	
	while(true) {
		 
		 while(gameOver != true)
		 {
			gameOver = e.getBoard()->isGameOver();
			
			while(e.getBoard()->getTurn() == 'O' && !e.getBoard()->isValid())
			{
				e.getBoard()->displayBoard();//Display the board on the server
				string boardState = e.getBoard()->boardToString();
				final_move = e.getBoard()->boardToString();
>>>>>>> master
				write(newsockfd, boardState.c_str(), boardState.length());//Display the board to the client (line by line)
				cout<<"\nWaiting for client: ";
				n = read(newsockfd,buffer,255);
				move = buffer;
<<<<<<< HEAD
				b.interpret(move,b);
				gameOver = b.isGameOver();
				if(gameOver == true) {
					string endGame = "Game_Over";
					write(newsockfd, endGame.c_str(), endGame.length()); //Display the board to the client (line by line)
					break;
				}	
				else {
					string continueGame = "Continue_Game";
					write(newsockfd, continueGame.c_str(), continueGame.length()); //Display the board to the client (line by line)
				}
			}
			
			vector<moves> possibleMoves = b.viewPossibleMoves();
			if(choice == 1)
				b.easyAI();
			b.snapshot();	
		 }
		 
		string final_move = b.boardToString();
		write(newsockfd, final_move.c_str(), final_move.length());//Display the board to the client (line by line)
		write(newsockfd, final_move.c_str(), final_move.length());
		cout << "\n\nGAME OVER!!!";
		//b.displayRecord();for debugging undo/snapchot fnctions
		usleep(1);
=======
				bzero(buffer,256);
				//cout << move << "\n\n";
				move = tempParse(move);
				//cout << move << "\n\n";
				e.getBoard()->interpret(move,(*e.getBoard()));
				
				if(e.getBoard()->isValid()) {
					e.getBoard()->changeTurns();
					e.getBoard()->setValidFalse();
				}
			}
			
			if(e.getBoard()->isValid()) 
				cout << e.getBoard()->getTurn();
			
			while(e.getBoard()->getTurn() == 'X' )
			{
				e.easyAI();
				/*Becca- once you finish your AI, uncomment this out and remove the line directly above this
				if(choice_difficulty == 1)
					easyAI();
				else if(choice_difficulty == 2)
					mediumAI();
				else
					hardAI();
				*/
			}
			
			gameOver = e.getBoard()->isGameOver();
			e.getBoard()->setValidFalse();
			e.getBoard()->snapshot(record, *e.getBoard());
		 }
		
		final_move = e.getBoard()->boardToString();
		string game_over = "\n\nGAME OVER!!!\n";
		write(newsockfd, final_move.c_str(), final_move.length()); //Display the board to the client (line by line)
		write(newsockfd, game_over.c_str(), game_over.length()); //Tell the client the game is over
		cout << game_over;
		usleep(1); 
>>>>>>> master
		close(newsockfd);
		close(sockfd);
		break;
	 }
	 return 0; 
}
